'------------------------------------------------------------
'ATTINY26 AVWT-metr
'
'pchela5 for http://avrproject.ru
'------------------------------------------------------------
$regfile = "attiny26.dat"
$crystal = 8000000
$hwstack = 32
$swstack = 16
$framesize = 32


 Dim I As Byte
 Dim Xa64 As Dword
 Dim Xa As Word At Xa64 Overlay
 Dim Xv64 As Dword
 Dim Xv As Word At Xv64 Overlay
' Dim T64 As Dword
 Dim T As Word                                              'At T64 Overlay
' Dim Tt As Word
 Dim Adc64 As Dword
 Dim Adcvolume As Word At Adc64 Overlay
 Dim V As Single
 Dim A As Single
 Dim W As Single
 Dim Ti As Single

'    4,096 
'     5   -    = 20,46 
'   5     - 1  -    ADC = 250
'    = 5 / 250 = 0,02
'   0,01 
'    20   -      = 20,46 
'  10     - 0,01*10*20  -    ADC = 500
'    = 10 / 500 = 0,02

 Const Dv = 0.02                                            '  
 Const Di = 0.025                                           '   
 Const Dtm = 0.4                                            '  
 Const Dt = 683                                             '  
 Const Dp = 100                                             '  40 

Alarm Alias Portb.6
Ddrb.6 = 1
Halt Alias Porta.7
Ddra.7 = 1

Config Adc = Single , Prescaler = Auto , Reference = Off
Start Adc

Config Lcd = 16 * 2
Config Lcdpin = Pin , E = Portb.4 , Rs = Portb.5 , Db4 = Portb.3 , Db5 = Portb.2 , Db6 = Portb.1 , Db7 = Portb.0

Softreset:

Initlcd
Cursor Off
Cls

Reset Alarm
Set Halt


Waitms 1000

'Tt = Getadc(0 , 12)                                         ' 
'Tt = 0

Do                                                          '  

      Adc64 = 0
      Xv = 0

      For I = 0 To 255

      Adcvolume = Getadc(2)
      Xv64 = Xv64 + Adc64                                   ' 

      Next
      Shift Xv64 , Right , 8                                '   64    
      V = Xv * Dv                                           '  
      If Xv > 1000 Then Exit Do                             '     20 


      Xa64 = 0
      Adc64 = 0

      For I = 0 To 255

      Adcvolume = Getadc(0 , 11)
      Xa64 = Xa64 + Adc64                                   ' 

      Next

      Shift Xa64 , Right , 8
      A = Xa * Di                                           '   
      If Xa > 550 Then Exit Do                              '     12 

      W = V * A                                             '

      T = 0

      For I = 0 To 63


      T = T + Getadc(3)                                     ' 

      Next

      Shift T , Right , 6

      T = T - Dt                                            '  
      Ti = T * Dtm                                          '  

      If T > Dp Then
      Set Alarm                                             '   
      Else
      Reset Alarm
      End If

      If T > 200 Then Exit Do                               '     80 

      Locate 1 , 1                                          '  

      Lcd V

      Locate 1 , 5
      Lcd " V "

      Locate 1 , 8

      Lcd A

      Locate 1 , 12
      Lcd " A   "

      Locate 2 , 1
      Lcd W

      Locate 2 , 5
      Lcd " W   "

      Locate 2 , 10
      Lcd Ti

      Locate 2 , 12
  '    Lcd Chr(223) ; "C   "
      Lcd " C    "

      Waitms 500
      Loop

Set Alarm
Reset Halt

      For I = 1 To 90

      Waitms 500

      Next

Goto Softreset

End



'     Ss = Fusing(v , "#.##")
'      1wreset
'      1wwrite &HCC                                          '    
'      1wwrite &H44                                          '  
'      Waitms 750                                             '   
'      1wreset
'      1wwrite &HCC
'      1wwrite &HBE                                          '    
'      Byte0 = 1wread()                                      '   
'      Byte1 = 1wread()                                      '   
'      Shift Byte0 , Right , 4                               '      4  (2*2*2*2=16)
'      Shift Byte1 , Left , 4                                '      4  (2*2*2*2=16)
'      T = Byte0 + Byte1                                     '      


' ADMUX = &B01101011
'    (7,6)     (4-0)
' .  .84
' Bit 5  ADLAR: ADC Left Adjust Result -      
' .  .87

' ADCSR  = &B01101011

'     
' 7 - / , 6,5 -  , 4,3 - , 2-0 - 
' .  .86

' ADC Data Register  ADCL  and ADCH

' http://www.avrfreaks.net/index.php?name=PNphpBB2&file=printview&t=110304&start=0
' "START ADC" - as with this f*ck compiler it does not work
' $asm
'     in r16, &h06                                            ' ADCSRA
'     ori r16, &h40                                           ' ADSC
'     Out &H06 , R16
' $end Asm